#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Version=beta
#AutoIt3Wrapper_Icon=SpotLyric.ico
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Comment=SpotLyric
#AutoIt3Wrapper_Res_Description=SpotLyric
#AutoIt3Wrapper_Res_Fileversion=0.2.0.0
#AutoIt3Wrapper_Res_LegalCopyright=2016 Michael Michta
#AutoIt3Wrapper_Res_SaveSource=y
#AutoIt3Wrapper_Res_Language=1033
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#Region Includes and options
#NoAutoIt3Execute
#include <File.au3>
#include <Misc.au3>
#include <String.au3>
#include <GuiConstantsEx.au3>
#include <EditConstants.au3>
#include <ButtonConstants.au3>
#include <WindowsConstants.au3>
#include <Inet.au3>
#include <GUIEdit.au3>
#include ".\Res\_HotKey.au3"

Opt("WinTitleMatchMode", 4)

#Region Ensure only one copy is run at a time
_Singleton("ba8830d0-4471-4f0e-9968-2b0b09167927_38871e04-5aad-4b38-bbf5-fa06a5e86dab")
#EndRegion Ensure only one copy is run at a time

#Region Include icon used for button
If FileExists(@ScriptDir & "\Theme\Theme.ico") Then
	Global $sIcon = @ScriptDir & "\Theme\Theme.ico"
Else
	Global $sIcon = _TempFile(@TempDir, "~", ".ico")
	FileInstall(".\SpotLyric.ico", $sIcon)
EndIf
#EndRegion Include icon used for button

#Region Declare global variables
Global Const $sVerInfo = "0.2B"
Global $oMyError = ObjEvent("AutoIt.Error", "MyErrFunc")
Global $hSpotify, $Edit, $hGUIMain
Global $OptMediaPlayer = IniRead(@ScriptDir & "\SpotLyric.ini", "Main", "Player", "S")
Global $OptEngine = IniRead(@ScriptDir & "\SpotLyric.ini", "Main", "Engine", "G")
Global $bOptAOT = IniRead(@ScriptDir & "\SpotLyric.ini", "Main", "AlwaysOnTop", 1)
Global $OptUHK = IniRead(@ScriptDir & "\SpotLyric.ini", "Main", "UseHotkey", 0)
Global $OptHK = IniRead(@ScriptDir & "\SpotLyric.ini", "Main", "Hotkey", "{launch_media}")
Global $OptWinColor = IniRead(@ScriptDir & "\Theme\Theme.ini", "Window", "Color", 0x57C200)
Global $OptFontColor = IniRead(@ScriptDir & "\Theme\Theme.ini", "Font", "Color", 0x57C200)
Global $OptFontBGColor = IniRead(@ScriptDir & "\Theme\Theme.ini", "Font", "BGColor", 0xFFFFFF0)
Global $OptFontName = IniRead(@ScriptDir & "\Theme\Theme.ini", "Font", "Name", "Constantia")
Global $OptFontSize = IniRead(@ScriptDir & "\Theme\Theme.ini", "Font", "Size", 12)
Global $OptFontWeight = IniRead(@ScriptDir & "\Theme\Theme.ini", "Font", "Weight", 800)
Global $OptFontAttrib = IniRead(@ScriptDir & "\Theme\Theme.ini", "Font", "Atrrib", 0)
Global $OldArray[2] = [0, 0], $NewArray, $InputArtist, $InputTitle
;Global $NoTrack = 0
#EndRegion Declare global variables


#Region Hook Spotify Window Handle
Global $hSpotify = WinGetHandle("[class:SpotifyMainWindow]")
If @error Then
	MsgBox(0, "SpotLyric:Error", "Failed to create and/or hook Spotify Handle. ")
	Exit
EndIf
#EndRegion Hook Spotify Window Handle

#Region  Exit the app if the user quits Spotify
AdlibRegister("_HandleChecker", 500)
Func _HandleChecker()
	If Not WinExists($hSpotify) Then Exit
EndFunc   ;==>_HandleChecker
#EndRegion  Exit the app if the user quits Spotify

#Region Create GUI
Global $hGUIMain = GUICreate("SpotLyric", 316, 80)
GUISetBkColor($OptWinColor)
Global $Edit = GUICtrlCreateEdit("", 8, 17, 233, 49, BitOR($ES_CENTER, $ES_READONLY, $ES_WANTRETURN))
GUICtrlSetFont(-1, $OptFontSize, $OptFontWeight, $OptFontAttrib, $OptFontName)
GUICtrlSetColor($Edit, $OptFontColor)
GUICtrlSetBkColor($Edit, $OptFontBGColor)
$hButtonLoockup = GUICtrlCreateButton("", 246, 7, 64, 64, $BS_ICON)
GUICtrlSetImage(-1, $sIcon)
GUICtrlSetTip($hButtonLoockup, "secondary-click for menu")
If $sIcon <> @ScriptDir & "\Theme\Theme.ico" Then FileDelete($sIcon) ;Delete temp file
$hMenu = GUICtrlCreateContextMenu($hButtonLoockup)
$hMenuEngine = GUICtrlCreateMenu("Engine", $hMenu)
$hMenuItemLW = GUICtrlCreateMenuItem("LyricWiki", $hMenuEngine, Default, 1)
$hMenuItemGoog = GUICtrlCreateMenuItem("Google", $hMenuEngine, Default, 1)
$hMenuHK = GUICtrlCreateMenu("HotKey", $hMenu)
$hMenuItemUHK = GUICtrlCreateMenuItem("Use HotKey", $hMenuHK)
$hMenuItemCHK = GUICtrlCreateMenuItem("Change HotKey", $hMenuHK)
GUICtrlCreateMenuItem("", $hMenu)
$hMenuItemAOT = GUICtrlCreateMenuItem("Always on top", $hMenu)
GUICtrlCreateMenuItem("", $hMenu)
$hMenuItemAbout = GUICtrlCreateMenuItem("About SpotLyric", $hMenu)
#EndRegion Create GUI

#Region Set always on top state and check the menu item accordingly
SetCB($hMenuItemAOT, $bOptAOT)
Switch $bOptAOT
	Case 1
		WinSetOnTop($hGUIMain, "", 1)
	Case 0
		WinSetOnTop($hGUIMain, "", 0)
EndSwitch
#EndRegion Set always on top state and check the menu item accordingly

#Region Set up other items check states
SetCB($hMenuItemLW, ($OptEngine = "L"))
SetCB($hMenuItemGoog, ($OptEngine = "G"))
SetCB($hMenuItemUHK, $OptUHK)
#EndRegion Set up other items check states

#Region Enable syncing
AdlibRegister("Sync", 100)
#EndRegion Enable syncing

#Region Enable Hotkey if set
If $OptUHK = 1 Then SetHotKey(1)
#EndRegion Enable Hotkey if set

#Region Display the GUI
GUISetState(@SW_SHOW)
#EndRegion Display the GUI

#Region Main loop
While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
		Case $hButtonLoockup
			OnLookUp()
		Case $hMenuItemAOT
			$bOptAOT = ReturnToogle($hMenuItemAOT)
			IniWrite(@ScriptDir & "\SpotLyric.ini", "Main", "AlwaysOnTop", $bOptAOT)
			Switch $bOptAOT
				Case 1
					WinSetOnTop($hGUIMain, "", 1)
				Case 0
					WinSetOnTop($hGUIMain, "", 0)
			EndSwitch
		Case $hMenuItemLW
			$OptEngine = "L"
			IniWrite(@ScriptDir & "\SpotLyric.ini", "Main", "Engine", "L")
		Case $hMenuItemGoog
			$OptEngine = "G"
			IniWrite(@ScriptDir & "\SpotLyric.ini", "Main", "Engine", "G")
		Case $hMenuItemUHK
			$OptUHK = ReturnToogle($hMenuItemUHK)
			IniWrite(@ScriptDir & "\SpotLyric.ini", "Main", "UseHotKey", $OptUHK)
			SetHotKey($OptUHK)
		Case $hMenuItemCHK
			$sHotkey = _ChooseHotKey($OptHK, 0, 'Choose HotKey', Default, Default, Default, Default, $hGUIMain)
			If Not @error Then
				$OptHK = $sHotkey
				IniWrite(@ScriptDir & "\SpotLyric.ini", "Main", "HotKey", $OptHK)
				SetHotKey(0)
				SetHotKey(1)
			EndIf
		Case $hMenuItemAbout
			MsgBox(64, "About", "SpotLyric V" & $sVerInfo & @CRLF & "Copyright 2016 Michael Michta", Default, $hGUIMain)
	EndSwitch
WEnd
#EndRegion Main loop

#Region Function that is triggered when lookup button or hotkey is pressed
Func OnLookUp()
	Local $sTrack, $asSplit, $Artist, $sTitle, $Q, $Site, $Lyrics, $GUILyrics, $EditL
	$sTrack = GUICtrlRead($Edit)
	If $sTrack = "" Then Return
	$asSplit = StringSplit($sTrack, @CRLF, 1)
	$Artist = StringLeft($asSplit[1], 30)
	$sTitle = StringLeft($asSplit[2], 30)
	Switch $OptEngine
		Case "G"
			$Q = StringReplace(CleanString($Artist & " " & $sTitle & " lyrics"), " ", "%20")
			ShellExecute("http://www.google.com/search?q=" & $Q)
		Case "L"
			$Q = StringReplace(CleanString($Artist & ":" & $sTitle), " ", "_")
			ShellExecute("http://lyrics.wikia.com/" & $Q)
	EndSwitch
EndFunc   ;==>OnLookUp
#EndRegion Function that is triggered when lookup button or hotkey is pressed

#Region HotKey Function
Func SetHotKey($Mode)
	Switch $Mode
		Case 1 ;Enable HotKey
			HotKeySet($OptHK, "OnLookUp")
		Case 0 ;Disable HotKey
			HotKeySet($OptHK)
	EndSwitch
EndFunc   ;==>SetHotKey
#EndRegion HotKey Function

#Region Function to sync track data with Spotify
Func Sync()
	Local $sTrack
	If WinExists($hSpotify) Then
		$sTrack = GetTrack()
		If GUICtrlRead($Edit) <> $sTrack Then GUICtrlSetData($Edit, $sTrack)
	EndIf
EndFunc   ;==>Sync
#EndRegion Function to sync track data with Spotify
;#include<Array.au3>;;DEBUG
#Region Function to get track info from Spotify
;Rage Against The Machine - Township Rebellion - Remastered
Func GetTrack()
	Local $sTitle, $sReturn, $iCounter
	$sTitle = WinGetTitle($hSpotify)
	$sTitle = StringReplace($sTitle, " - ", @CRLF)
	$sTitle = StringReplace($sTitle, "  ", @CRLF)
	$asSplit = StringSplit($sTitle, @CRLF, 1)
	;_ArrayDisplay($asSplit);;DEBUG
	If $asSplit[0] < 2 Then Return "***NO TRACK***" & @CRLF & "***DETECTED***"
	Select
		Case $asSplit[0] = 2
			$sReturn = $asSplit[1] & @CRLF & $asSplit[2]

		Case $asSplit[0] >= 3
			$sReturn = $asSplit[1] & @CRLF
			For $iCounter = 2 To $asSplit[0] Step 1
				$sReturn &= $asSplit[$iCounter] & " - "
			Next
			$sReturn = StringTrimRight($sReturn, 3)

	EndSelect

	Return StringStripWS($sReturn, 3)
EndFunc   ;==>GetTrack
#EndRegion Function to get track info from Spotify

#Region Function to toggle a checkboxes state and return its new value
Func ReturnToogle($hItem)
	If BitAND(GUICtrlRead($hItem), $GUI_Checked) = $GUI_Checked Then
		GUICtrlSetState($hItem, $GUI_UNCHECKED)
		Return 0
	Else
		GUICtrlSetState($hItem, $GUI_Checked)
		Return 1
	EndIf
EndFunc   ;==>ReturnToogle
#EndRegion Function to toggle a checkboxes state and return its new value

#Region Function for setting the state of a checkbox
Func SetCB($hItem, $iValue)
	Switch $iValue
		Case 1
			GUICtrlSetState($hItem, $GUI_Checked)
		Case 0
			GUICtrlSetState($hItem, $GUI_UNCHECKED)
	EndSwitch
EndFunc   ;==>SetCB
#EndRegion Function for setting the state of a checkbox

#Region Function to clean invalid chars from url strings
Func CleanString($sString)
	Local $iCounter, $sReturn
	For $iCounter = 1 To StringLen($sString)
		$sChar = StringMid($sString, $iCounter, 1)
		If Not (StringIsAlNum($sChar) Or $sChar = " ") Then
			$sReturn &= "%" & Hex(Asc($sChar), 2)
		Else
			$sReturn &= $sChar
		EndIf
	Next
	Return $sReturn
EndFunc   ;==>CleanString
#EndRegion Function to clean invalid chars from url strings